<sqtm-core-configurable-banner />

<div
  #mainContainer
  [class.workbench-layout-2-cols]="showSelectReportPanel$ | async"
  style="position: relative"
  class="full-height full-width flex-row overflow-hidden neutral-background-color"
>
  <!--  Left part, controls are here-->
  @if (showSelectReportPanel$ | async) {
    <div
      class="full-height flex-fixed-size flex-column overflow-hidden select-report-zone"
    >
      <div class="flex-row">
        <sqtm-core-back-button
          class="m-t-6 p-10"
          (buttonPressed)="handleCancel()"
        >
        </sqtm-core-back-button>
        <div
          class="sqtm-core-screen-title title__underline p-b-25 m-t-10 m-l-20 flex-fixed-size"
        >
          {{
            'sqtm-core.custom-report-workspace.create-report.selection.title'
              | translate
          }}
        </div>
      </div>
      <div class="full-width full-height p-10" style="overflow-y: auto">
        @if (unInstalledReports$ | async; as unAvailablePlugin) {
          @if (unAvailablePlugin.length > 0) {
            <div
              class="full-width p-10 container-border container-background-color flex-column m-b-20"
            >
              <span class="block-title">{{
                'sqtm-core.custom-report-workspace.reports.uninstalled.label'
                  | translate
                  | capitalize
              }}</span>
              <sqtm-app-uninstalled-report-list
                [attr.data-test-element-id]="'uninstalled-report-list'"
                [reports]="unAvailablePlugin"
              ></sqtm-app-uninstalled-report-list>
            </div>
          }
        }
        <div
          class="full-width p-10 container-border container-background-color flex-column"
        >
          <span class="block-title">{{
            'sqtm-core.custom-report-workspace.create-report.selection.phase.preparation'
              | translate
              | capitalize
          }}</span>
          <sqtm-app-report-list
            [attr.data-test-element-id]="'preparation-phase-report-list'"
            [reports]="availablePreparationPhaseReports$ | async"
            (reportChanged)="changeSelectedReport($event)"
          ></sqtm-app-report-list>
        </div>
        <div
          class="full-width p-10 container-border container-background-color flex-column m-t-20 m-b-10"
        >
          <span class="block-title">{{
            'sqtm-core.custom-report-workspace.create-report.selection.phase.execution'
              | translate
              | capitalize
          }}</span>
          <sqtm-app-report-list
            [attr.data-test-element-id]="'execution-phase-report-list'"
            [reports]="availableExecutionPhaseReports$ | async"
            (reportChanged)="changeSelectedReport($event)"
          ></sqtm-app-report-list>
        </div>
        @if ((availableVariousReports$ | async).length != 0) {
          <div
            class="full-width p-10 container-border container-background-color flex-column m-t-20 m-b-10"
          >
            <span class="block-title">{{
              'sqtm-core.custom-report-workspace.create-report.selection.phase.various'
                | translate
                | capitalize
            }}</span>
            <sqtm-app-report-list
              [attr.data-test-element-id]="'various-phase-report-list'"
              [reports]="availableVariousReports$ | async"
              (reportChanged)="changeSelectedReport($event)"
            ></sqtm-app-report-list>
          </div>
        }
      </div>
    </div>
  }
  @if (selectedReport$ | async; as selectedReport) {
    <div
      class="full-height full-width flex-column overflow-hidden"
      [attr.data-test-report-id]="selectedReport.id"
    >
      <div class="full-width flex-fixed-size flex-row">
        <div class="m-l-20 flex-fixed-size">
          <i
            class="m-t-20 __hover_pointer"
            nz-icon
            [nzType]="showSelectReportPanelIcon$ | async"
            nzTheme="outline"
            [attr.data-test-element-id]="'toggle-report-selector'"
            (click)="toggleSelectReportPanel()"
          ></i>
        </div>
        <div
          class="sqtm-core-screen-title p-b-25 m-t-10 m-l-20 full-width"
          [attr.data-test-element-id]="'selected-report-title'"
        >
          {{ selectedReport.label }}
        </div>
      </div>
      <div
        class="p-15 full-height"
        style="overflow-y: auto"
        [formGroup]="formGroup"
      >
        <nz-collapse [nzBordered]="false" class="entity-view-collapse-panel">
          <nz-collapse-panel
            [nzHeader]="informationTitle"
            class="anchor"
            [nzActive]="true"
          >
            <ng-template #informationTitle>
              <div class="entity-view-collapse-panel-title">
                {{ 'sqtm-core.generic.label.information.plural' | translate }}
              </div>
            </ng-template>
            <div class="m-10">
              <!-- Natives attributes -->
              <div class="information-form p-4">
                <label class="label label__align_right">{{
                  'sqtm-core.entity.generic.name.label' | translate
                }}</label>
                <sqtm-core-text-field
                  #nameField
                  [initialFocus]="true"
                  [formGroup]="formGroup"
                  [fieldName]="'name'"
                  [serverSideFieldValidationError]="serverSideValidationErrors"
                ></sqtm-core-text-field>
                <label class="label label__align_right">{{
                  'sqtm-core.generic.label.resume' | translate
                }}</label>
                <sqtm-core-text-field
                  [formGroup]="formGroup"
                  [fieldName]="'summary'"
                ></sqtm-core-text-field>
                <label class="label label__align_right">{{
                  'sqtm-core.entity.generic.description.label' | translate
                }}</label>
                <sqtm-core-rich-text-field
                  [formGroup]="formGroup"
                  [fieldName]="'description'"
                >
                </sqtm-core-rich-text-field>
              </div>
            </div>
          </nz-collapse-panel>
        </nz-collapse>
        <nz-collapse
          [nzBordered]="false"
          class="entity-view-collapse-panel"
          formArrayName="criteria"
        >
          <nz-collapse-panel
            [nzHeader]="criteriaTitle"
            class="anchor"
            [nzActive]="true"
          >
            <ng-template #criteriaTitle>
              <div class="entity-view-collapse-panel-title">
                {{ 'sqtm-core.search.generic.criteria.label' | translate }}
              </div>
            </ng-template>
            @for (input of selectedReport.inputs; track input; let i = $index) {
              <div class="full-width">
                @if (isReportOptionGroup(input)) {
                  <sqtm-app-composite-report-input
                    [reportInput]="input"
                    [subFormGroup]="getSubForm(i)"
                    [errors]="getSubForm(i).errors"
                  >
                  </sqtm-app-composite-report-input>
                } @else {
                  @if (isReportInputsGroup(input)) {
                    <sqtm-app-inputs-group-report
                      [subFormGroup]="getSubForm(i)"
                      [reportInput]="input"
                      [errors]="getSubForm(i).errors"
                    ></sqtm-app-inputs-group-report>
                  } @else {
                    <sqtm-app-simple-report-input
                      [reportInput]="input"
                      [subFormGroup]="getSubForm(i)"
                      [errors]="getSubForm(i).errors"
                    ></sqtm-app-simple-report-input>
                  }
                }
              </div>
            }
          </nz-collapse-panel>
        </nz-collapse>
      </div>
      <div class="full-width flex-fixed-size flex-row p-10">
        <button
          [attr.data-test-element-id]="'download-report'"
          [disabled]="!(showDownloadButton$ | async)"
          class="flex-fixed-size m-l-auto"
          nz-button
          nzType="primary"
          (click)="handleDownload(reportDefinition)"
        >
          {{ 'sqtm-core.entity.generic.download' | translate }}
        </button>
        <button
          [attr.data-test-element-id]="'save-report'"
          [disabled]="showSpinner$ | async"
          class="flex-fixed-size m-l-10"
          nz-button
          nzType="primary"
          (click)="handleAdd()"
        >
          {{ saveLabel() }}
        </button>
        <button
          [attr.data-test-element-id]="'cancel'"
          [disabled]="showSpinner$ | async"
          class="flex-fixed-size m-l-10 m-r-20"
          nz-button
          nzType="default"
          (click)="handleCancel()"
        >
          {{ 'sqtm-core.generic.label.cancel' | translate }}
        </button>
      </div>
    </div>
  }
  @if (showSpinner$ | async) {
    <div class="loading-overlay">
      <div class="full-width full-height loading">
        <i
          class="current-workspace-main-color"
          nz-icon
          nzType="loading"
          nzTheme="outline"
        ></i>
      </div>
    </div>
  }
</div>
